<script setup lang="ts">
import { onMounted } from 'vue'
import { nextTick, ref } from 'vue'

import type { StoreExp } from '@/types/StoreExpenses'
import { useStoreExp } from '@/stores/storeexpenses'
import type { VForm } from 'vuetify/components'
import { useDate } from 'vuetify'
import { useBranchStore } from '@/stores/branch'
import ReceiptDialog from '@/components/stroeexpenDialog.vue'

const storeexps = ref<StoreExp[]>([])
const storeexpsStore = useStoreExp()
const headers = [
  {
    title: 'ID',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Status',
    value: 'status',
    key: 'status'
  },
  {
    title: 'ElectricBill',
    value: 'electricBill',
    key: 'electricBill'
  },
  {
    title: 'WaterBill',
    value: 'waterBill',
    key: 'waterBill'
  },
  {
    title: 'Total',
    value: 'total',
    key: 'total'
  },
  {
    title: 'Due-Date',
    value: 'due_date',
    key: 'due_date'
  },
  {
    title: 'Branches',
    key: 'branch',
    value: (item: any | StoreExp) => item.branch.name
  },
  {
    title: 'View',
    key: 'view',
    sortable: false
  }
]
const form = ref(false)
const loading = ref(false)
const dialog = ref(false)
const dialogDelete = ref(false)
const refForm = ref<VForm | null>(null)
const usebranchStore = useBranchStore()
let editedIndex = -1
function onSubmit() {}

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    storeexpsStore.clearForm()
  })
}

async function deleteItemConfirm() {
  await storeexpsStore.deleteStoreExp()
  closeDelete()
}

async function editItem(item: StoreExp) {
  if (!item.id) return
  await storeexpsStore.getStoreExp(item.id)
  dialog.value = true
}

async function deleteItem(item: StoreExp) {
  if (!item.id) return
  await storeexpsStore.getStoreExp(item.id)
  dialogDelete.value = true
  editedIndex = -1
}
function closeDialog() {
  dialog.value = false
  nextTick(() => {
    storeexpsStore.clearForm()
  })
}

onMounted(async () => {
  await storeexpsStore.getStoreExps()
})

const search = ref('')

async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  await storeexpsStore.saveStoreExp()
  closeDialog()
}

//เพิ่มใหม่
function showItemsWithSameDate() {
  const dateToFilter = storeexpsStore.StoreExps[0]?.due_date
  if (dateToFilter) {
    // Filter items with the same date
    const filteredItems = storeexpsStore.StoreExps.filter(
      (item: StoreExp) => item.due_date === dateToFilter
    )
    // Set the filtered items to be displayed
    storeexpsStore.setStoreExps(filteredItems)
  }
}
</script>

<template>
  <div class="app-container">
    <v-data-table
      :headers="headers"
      :search="search"
      :items="storeexpsStore.StoreExps"
      class="custom-datatable"
    >
      <template v-slot:top>
        <v-toolbar flat style="background-color: rgb(247, 156, 82)">
          <v-toolbar-title style="color: white">Store Expenses</v-toolbar-title>
          <v-spacer></v-spacer>

          <v-text-field
            rounded
            v-model="search"
            label="Search"
            prepend-inner-icon="mdi-magnify"
            variant="solo"
            hide-details
            single-line
          ></v-text-field>

          <v-btn icon="mdi-cached" color="text-black" @click="storeexpsStore.getStoreExps"></v-btn>
          <v-divider class="mx-4" inset vertical></v-divider>

          <v-spacer></v-spacer>

          <v-dialog v-model="dialog" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn
                prepend-icon="mdi-plus"
                outlined
                v-bind="props"
                style="color: white; background-color: green"
              >
                New Bill
              </v-btn>
            </template>
            <v-card>
              <v-card-title>
                <span class="text-h5">Add Bill</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="6">
                        <v-combobox
                          label="Status"
                          v-model="storeexpsStore.editedStoreExp.status"
                          :items="[
                            { title: 'Successful', value: 'Successful' },
                            { title: 'Pending', value: 'Pending' }
                          ]"
                          :rules="[(v) => !!v || 'Field is required']"
                          :return-object="false"
                        ></v-combobox>
                      </v-col>
                      <v-col cols="12" sm="6">
                        <v-text-field
                          v-model="storeexpsStore.editedStoreExp.waterBill"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="waterBill Total"
                          type="number"
                        >
                        </v-text-field>
                      </v-col>
                      <v-col cols="12" sm="6">
                        <v-text-field
                          v-model="storeexpsStore.editedStoreExp.electricBill"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="electricBill Total"
                          type="number"
                        >
                        </v-text-field>
                      </v-col>
                      <v-col cols="12" sm="6">
                        <v-text-field
                          v-model="storeexpsStore.editedStoreExp.due_date"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="DueDate"
                          type="date"
                        >
                        </v-text-field>
                      </v-col>
                      <v-col cols="12" sm="6">
                        <v-combobox
                          v-model="storeexpsStore.editedStoreExp.branch"
                          :items="usebranchStore.branchs"
                          item-title="name"
                          item-value="id"
                          label="Select branchs"
                          :return-object="true"
                        ></v-combobox>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-form>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDialog"> Close </v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>

          <v-dialog v-model="dialogDelete" max-width="500px">
            <v-card>
              <v-card-title class="text-h5">คุณแน่ใจหรือไม่ว่าต้องการลบผู้ใช้รายนี้</v-card-title>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDelete">Cancel</v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm">OK</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>
      <template v-slot:[`item.view`]="{ item }">
        <ReceiptDialog :storeExp="item"></ReceiptDialog>
      </template>
      <template v-slot:no-data>
        <v-btn color="rgb(214, 175, 125)" @click="storeexpsStore.getStoreExps"> Reset </v-btn>
      </template>
    </v-data-table>
  </div>
</template>
